//-----------------------------------------------------------------------------
//
//  Filename:   SwitchState.cc
//
//  Description:
//  Class SwitchState implementation generated by enum_gen. 
//
//-----------------------------------------------------------------------------
     
#include "SwitchState.h"
#include <stdlib.h>
     
     
//-----------------------------------------------------------------------------
     
SwitchState::EnumDefStruct  SwitchState::m_defArr[] = 
{
    EnumDefStruct (     0, "OFF"        ), 
    EnumDefStruct (    33, "LOW"        ), 
    EnumDefStruct (    66, "MED"        ), 
    EnumDefStruct (   100, "HI"         ), 
    EnumDefStruct (   101, "_UNDEFINED" ),
};
     
const SwitchState  SwitchState::OFF        (&m_defArr[0]); 
const SwitchState  SwitchState::LOW        (&m_defArr[1]); 
const SwitchState  SwitchState::MED        (&m_defArr[2]); 
const SwitchState  SwitchState::HI         (&m_defArr[3]); 
const SwitchState  SwitchState::_UNDEFINED (&m_defArr[4]);
     
     
short  SwitchState::m_defArrCount = sizeof (SwitchState::m_defArr) /
                                     sizeof (EnumDefStruct);
     
const char*  SwitchState::m_errorMsg = 
    "ERROR: SwitchState undefined";
     
     
//-----------------------------------------------------------------------------
     
SwitchState::SwitchState (
    const string&  name)
{
    for (int k = 0; k < m_defArrCount - 1; k++) 
    {
        if (m_defArr[k].m_name == name)
        {
            m_defPtr = &m_defArr[k];
            return;
        }
    }
    m_defPtr = _UNDEFINED.m_defPtr;
}
     
//-----------------------------------------------------------------------------
     
SwitchState::SwitchState (
    const int  ival )
{
    for (int k = 0; k < m_defArrCount - 1; k++) 
    {
        if (m_defArr[k].m_value == ival)
        {
            m_defPtr = &m_defArr[k];
            return;
        }
    }
    m_defPtr = _UNDEFINED.m_defPtr;
}
     
//-----------------------------------------------------------------------------
     
const char* SwitchState::GetLabel() const 
{
    if (m_defPtr)
    {
        return m_defPtr->m_name.c_str();
    }
    return _UNDEFINED.m_defPtr->m_name.c_str();
}
     
//-----------------------------------------------------------------------------
     
string SwitchState::GetString() const 
{
    if (m_defPtr)
    {
        return m_defPtr->m_name;
    }
    return _UNDEFINED.m_defPtr->m_name;
}
     
//-----------------------------------------------------------------------------
     
SwitchState SwitchState::operator++() 
{
    if (m_defPtr < _UNDEFINED.m_defPtr)
    {
        m_defPtr++;
    }
    return *this;
}
     
//-----------------------------------------------------------------------------
// Postfix ++
     
SwitchState SwitchState::operator++(int) 
{
    SwitchState  tmp = *this;
    operator++();
    return tmp;
}
     
//-----------------------------------------------------------------------------
     
SwitchState SwitchState::operator--() 
{
    if (m_defPtr > m_defArr)
    {
        m_defPtr--;
    }
    else
    {
        m_defPtr = _UNDEFINED.m_defPtr;
    }
    return *this;
}
     
     
//-----------------------------------------------------------------------------
// Postfix --
     
SwitchState SwitchState::operator--(int) 
{
    SwitchState  tmp = *this;
    operator--();
    return tmp;
}
     
//-----------------------------------------------------------------------------
     
ostream& operator<< (
    ostream&  ostr,
    const SwitchState&  objref )
{
    ostr << " " << objref.GetString() << " "; 
    return ostr;
}
     
//-----------------------------------------------------------------------------
     
istream& operator>> (
    istream&  istr,
    SwitchState&  objref )
{
    string  name;
    istr >> name;
    objref = SwitchState (name);
     
    return istr;
}
     
//-----------------------------------------------------------------------------
     
void SwitchState::RangeError()
{
    cerr << m_errorMsg << endl;
    exit (1);
}
     
//-----------------------------------------------------------------------------
     
