inline void SkylineMatrix :: set (size_t x, int tot)
{
     sz = 0 ;
     d1 = x ;

     addr.resize (d1 + 1) ;
     stv.reserve (d1) ;

     wk2  = new valarray <double> (0., d1) ;
     v    = new valarray <double> (0., tot) ;

     diag = new valarray <double> (0., d1) ;
}

inline int SkylineMatrix :: read_matrix (FILE *fp)
{
   double val ;
   int size, nrow, ht1, ht2 = 0 ;

   fscanf (fp, "%d", &size) ;
   set (size) ;

   // read from file and set up addr vector
   addr[0] = 0 ;

   for (int i = 1 ; i < size ; i ++)
   {
      fscanf (fp, "%d", &nrow) ;
      ht1 = nrow - 1 ;

      fscanf (fp, "%lf", &val) ;
      (*diag)[i] = val ;
  
      // read values from file on to wk2 valarray
      for (int j = 0 ; j < ht1 ; j ++) ....

      fill _array (ht1) ;
      addr[i] = addr[i - 1] + ht2 ;

      ht2 = ht1 ;
      stv[i] = new Sliceiter (*v, slice (addr[i],
                ht1, 1)) ;
   }

   addr[d1] = addr[d1 - 1] + ht1 ;
   return d1 ;
}

void read_rhs (FILE *fp, int d1, valarray <double> 
 *rhs)
{
    // read rhs vector form file
    (*rhs) [i] = val ;
}

inline void SkylineMatrix :: fill_array (int ht)
{
   for (int i = ht - 1 ; i >= 0 ; i --)
     (*v) [sz ++] = (*wk2) [i] ;
}

void solve (Skyline Matrix &mt, valarray <double> 
 *rhs)
{
    decompose () ;
    backsub   () ;
}

void decompose (SkylineMatrix &mt)
{
    int i, j, k1, kk, size, d1 ;

    valarray <double> &diag = mt.diagarray () ;
    valarray <double> &wtmp = mt.tmparray  () ;

    d1 = mt.dim () ;

    for (int i = 1 ; i < d1 ; i ++)
    {
       Sliceiter &t1 = mt.column (i) ;
       size = t1.size ;

       for (j = 1 ; k1 = i - size ; j < size ; j ++)
       {
           Sliceiter &t2 = mt.column (k1 + j) ;

           kk = mt.first_row (j, k1 + j) ;
           t1[j] -= Sliceiter (t2, t2.size, kk).dot_product
                     (Sliceiter (t1, j, kk)) ;
       }

       Sliceiter t2 = Sliceiter (diag, i, t1) ;
       Sliceiter t3 = Sliceiter (wtmp, t1) ;

       t1 /= t2 ;
       diag[i] -= t1.dot_product (t3) ;
    }
}

inline double scale :: operator () (int i)
{
    return ss[i] * val ;
}

void backsub (SkylineMatrix &mt, valarray <double> &rhs)
{
   int d1 = mt.dim () ;

   for (int i = 1 ; i < d1 ; i ++)
   {
      Sliceiter &s1 = mt.column (i) ;
      rhs[i] -= s1.dot_product (sliceiter (rhs, i, s1)) ;
   }

   rhs /= mt.diagarray () ;

   for (int j = d1 - 1 ; j > 0 ; j --)
   {
      Sliceiter &s1 = mt.column (j) ;
      Sliceiter  s2 = Sliceiter (rhs, j, s1) ;

      s2 -= s1 * rhs[j] ;
   }
}

inline SkylineMatrix :: ~SkylineMatrix ()
{
    addr.clear () ;
    stv.clear  () ;

    delete v, diag, wk2 ;
}

