module matrixdata 
implicit none

double precision , allocatable :: sk(:), wk2(:), diag(:)
integer allocatable :: nk(:), nrow(:)
integer :: ndf, iunit, lds, ipos, njd, nid, nii ...
targer  :: sk, wk2, diag
doubleprecision , pointer :: skptr

contains

subroutine readmatrixdata 
// read data
end subroutine readmatrixdata

!....
end module matrixdata

module solver
use matrixdata
implicit none

contains

subroutine ldldecom ()
implicit none

integer :: i, j , ii
integer :: nj1, ni1, ni2, nkj
doubleprecision , pointer :: ptsk1vc(:), ptwk1vc(:),
 wk1scpt, skptr

do j = 2, ndf
   nj1 = nrow (j)
   njd = nk(j) - nj1

   do i = nj1 + 1, j - 1
     ni1 = max (nj1, nrow(i))
     ii  = i - 1
     if (ni1 <= ii) then
        skptr=>sk(i + njd)
        nid = nk(i) - nrow(i)
        skptr = skptr - dot_product (sk(ni1 + njd : ii
            + njd), sk (ni1 + nid : ii + nid))
     end if
   end do

   ptsk1vc=>sk(nj1 + njd : j - 1 + njd)
   ptwk1vc=>wk2(nj1 : j - 1)

   ptwk1vc = ptsk1vc / diag (nj1 : j - 1)
   diag(j) = diag(j) - dot_product (ptsk1vc, ptwk1vc)
   ptsk1vc = ptwk1vc
end do

end subroutine ldldecom

subroutine backsub (gd)
implicit none

double precision, intent(inout) :: gd(:)
integer :: j
integer :: nj1, njd
doubleprecision :: s1
target :: gd
doubleprecision, pointer :: ptgd1vc(:)

call ldldecom ()

do j = 2, ndf
   nj1 = nrow (j)
   njd = nk(j) - nj1

   gd(j) = gd (j) - dot_product(gd(nj1 : j - 1), sk (nj1
            + njd : j - 1 + njd)
end do

gd = gd / diag

do j = ndf, 2, -1
  nj1 = nrow(j)
  njd = nk(j) - nj1

  s1 = gd(j)
  gd(nj1 : j - 1) = gd (nj1 : j - 1) - s1 * sk(nj1 + njd :
                     j - 1 + njd)
end do

end subroutine backsub
